//=============================================================================
//
//  CLASS KDTree
//
//=============================================================================

#ifndef RAYTRACER_KDTREE_H
#define RAYTRACER_KDTREE_H

//== INCLUDES =================================================================
#include "Types.h"
#include "Surface.h"
#include "Accelerator.h"

//== CLASS DEFINITION =========================================================

/*!
	Uniform Grid.

*/
class KDTree: public Accelerator
{
//-------------------------------------------------------------- constructors
public:
	//! standard constructor
	KDTree( const SurfaceList *scene );

    // Destructor
    ~KDTree();

//--------------------------------------------------------------- intersections

    bool intersect( const Ray&     clRay, 
	   			    const double  t0, 
				    const double  t1, 
					TracingContext&  tContext ) const;
					
};
//=============================================================================
#endif // RAYTRACER_KDTree_H
//=============================================================================