//=============================================================================
//
//  CLASS UniformGrid
//
//=============================================================================

#ifndef RAYTRACER_UNIFORMGRID_H
#define RAYTRACER_UNIFORMGRID_H

//== INCLUDES =================================================================
#include "Types.h"
#include "Surface.h"
#include "Accelerator.h"

//== CLASS DEFINITION =========================================================

/*!
	Uniform Grid.

*/
class UniformGrid: public Accelerator
{
//-------------------------------------------------------------- constructors
public:
	//! standard constructor
	UniformGrid( const SurfaceList *scene );

    // Destructor
    ~UniformGrid();

//--------------------------------------------------------------- intersections

    bool intersect( const Ray&     clRay, 
	   			    const double  t0, 
				    const double  t1, 
					TracingContext&  tContext ) const;
					
};
//=============================================================================
#endif // RAYTRACER_UNIFORMGRID_H
//=============================================================================